# Modifier types

# FUN

# Reuben
# Frog
# Chicken
# Cow Tipper
# Thunder Struck
# Confetti

# ANNOYING

# Nausea
# Shove
# Hotbar Shuffle
# Gamemode Swap
# Rotation
# Reflection

# CHAOTIC

# Color Swap
# Flood
# Sandstorm
# Refactor
# Build Swap







# Set weights

execute if score #modifier_type value matches 1 run function build:modifiers/fun
execute if score #modifier_type value matches 2 run function build:modifiers/annoying
execute if score #modifier_type value matches 3 run function build:modifiers/chaotic







# Set one-time modifiers to zero

execute if entity @s[tag=modifier.frog      ] run scoreboard players set #modifier_weight_frog value 0
execute if entity @s[tag=modifier.chicken   ] run scoreboard players set #modifier_weight_chicken value 0
execute if entity @s[tag=modifier.flood     ] run scoreboard players set #modifier_weight_flood value 0
execute if entity @s[tag=modifier.sandstorm ] run scoreboard players set #modifier_weight_sandstorm value 0
execute if entity @s[tag=modifier.refactor  ] run scoreboard players set #modifier_weight_refactor value 0
execute if entity @s[tag=modifier.build_swap] run scoreboard players set #modifier_weight_build_swap value 0

scoreboard players operation #local arena = @s arena
scoreboard players set #boolean value 0
execute as @a[tag=!eliminated,tag=!skipped,tag=!modifier,tag=!modifier.build_swap] if score @s arena = #local arena run scoreboard players set #boolean value 1
execute if score #boolean value matches 0 run scoreboard players set #modifier_weight_build_swap value 0







# Sum up weights

scoreboard players set #input value 0
scoreboard players operation #input value += #modifier_weight_reuben value
scoreboard players operation #input value += #modifier_weight_frog value
scoreboard players operation #input value += #modifier_weight_chicken value
scoreboard players operation #input value += #modifier_weight_cow_tipper value
scoreboard players operation #input value += #modifier_weight_nausea value
scoreboard players operation #input value += #modifier_weight_shoved value
scoreboard players operation #input value += #modifier_weight_color_swap value
scoreboard players operation #input value += #modifier_weight_flood value
scoreboard players operation #input value += #modifier_weight_sandstorm value
scoreboard players operation #input value += #modifier_weight_hotbar_shuffle value
scoreboard players operation #input value += #modifier_weight_gamemode_swap value
scoreboard players operation #input value += #modifier_weight_thunder_struck value
scoreboard players operation #input value += #modifier_weight_refactor value
scoreboard players operation #input value += #modifier_weight_rotation value
scoreboard players operation #input value += #modifier_weight_reflection value
scoreboard players operation #input value += #modifier_weight_build_swap value
scoreboard players operation #input value += #modifier_weight_confetti value







# Pick a random modifier

function build:generic/rng
scoreboard players set #chosen_boolean value 0

scoreboard players operation #output value -= #modifier_weight_reuben value
execute if score #chosen_boolean value matches 0 if score #output value matches ..-1 run function build:modifiers/modifiers/reuben
scoreboard players operation #output value -= #modifier_weight_frog value
execute if score #chosen_boolean value matches 0 if score #output value matches ..-1 run function build:modifiers/modifiers/frog
scoreboard players operation #output value -= #modifier_weight_chicken value
execute if score #chosen_boolean value matches 0 if score #output value matches ..-1 run function build:modifiers/modifiers/chicken
scoreboard players operation #output value -= #modifier_weight_cow_tipper value
execute if score #chosen_boolean value matches 0 if score #output value matches ..-1 run function build:modifiers/modifiers/cow_tipper
scoreboard players operation #output value -= #modifier_weight_nausea value
execute if score #chosen_boolean value matches 0 if score #output value matches ..-1 run function build:modifiers/modifiers/nausea
scoreboard players operation #output value -= #modifier_weight_shoved value
execute if score #chosen_boolean value matches 0 if score #output value matches ..-1 run function build:modifiers/modifiers/shoved
scoreboard players operation #output value -= #modifier_weight_color_swap value
execute if score #chosen_boolean value matches 0 if score #output value matches ..-1 run function build:modifiers/modifiers/color_swap
scoreboard players operation #output value -= #modifier_weight_flood value
execute if score #chosen_boolean value matches 0 if score #output value matches ..-1 run function build:modifiers/modifiers/flood
scoreboard players operation #output value -= #modifier_weight_sandstorm value
execute if score #chosen_boolean value matches 0 if score #output value matches ..-1 run function build:modifiers/modifiers/sandstorm
scoreboard players operation #output value -= #modifier_weight_hotbar_shuffle value
execute if score #chosen_boolean value matches 0 if score #output value matches ..-1 run function build:modifiers/modifiers/hotbar_shuffle
scoreboard players operation #output value -= #modifier_weight_gamemode_swap value
execute if score #chosen_boolean value matches 0 if score #output value matches ..-1 run function build:modifiers/modifiers/gamemode_swap
scoreboard players operation #output value -= #modifier_weight_thunder_struck value
execute if score #chosen_boolean value matches 0 if score #output value matches ..-1 run function build:modifiers/modifiers/thunder_struck
scoreboard players operation #output value -= #modifier_weight_refactor value
execute if score #chosen_boolean value matches 0 if score #output value matches ..-1 run function build:modifiers/modifiers/refactor
scoreboard players operation #output value -= #modifier_weight_rotation value
execute if score #chosen_boolean value matches 0 if score #output value matches ..-1 run function build:modifiers/modifiers/rotation
scoreboard players operation #output value -= #modifier_weight_reflection value
execute if score #chosen_boolean value matches 0 if score #output value matches ..-1 run function build:modifiers/modifiers/reflection
scoreboard players operation #output value -= #modifier_weight_build_swap value
execute if score #chosen_boolean value matches 0 if score #output value matches ..-1 run function build:modifiers/modifiers/build_swap
scoreboard players operation #output value -= #modifier_weight_confetti value
execute if score #chosen_boolean value matches 0 if score #output value matches ..-1 run function build:modifiers/modifiers/confetti







# Play announcement sound

execute as @a[tag=target.modifier] at @s run playsound minecraft:event.raid.horn master @s ~ ~ ~ 100