# Fix signs

execute if score #forest_phase value matches 0 run data modify block -14 5 0 {} merge from storage build:data signs.forest.start.start
execute if score #forest_phase value matches 1.. run data modify block -14 5 0 {} merge from storage build:data signs.forest.start.in_session

data modify block -12 7 3 {} merge from storage build:data signs.forest.mode.up
data modify block -12 5 3 {} merge from storage build:data signs.forest.mode.down
execute if score #forest_mode value matches 0 run data modify block -12 6 3 {} merge from storage build:data signs.forest.mode.telephone
execute if score #forest_mode value matches 1 run data modify block -12 6 3 {} merge from storage build:data signs.forest.mode.tourney
execute if score #forest_mode value matches 2 run data modify block -12 6 3 {} merge from storage build:data signs.forest.mode.build_battle
execute if score #forest_mode value matches 3 run data modify block -12 6 3 {} merge from storage build:data signs.forest.mode.1v1s

data modify block -12 7 -3 {} merge from storage build:data signs.forest.time.up
data modify block -12 5 -3 {} merge from storage build:data signs.forest.time.down
execute if score #forest_time value matches 0 run data modify block -12 6 -3 {} merge from storage build:data signs.forest.time.1m
execute if score #forest_time value matches 1 run data modify block -12 6 -3 {} merge from storage build:data signs.forest.time.2m
execute if score #forest_time value matches 2 run data modify block -12 6 -3 {} merge from storage build:data signs.forest.time.3m
execute if score #forest_time value matches 3 run data modify block -12 6 -3 {} merge from storage build:data signs.forest.time.5m
execute if score #forest_time value matches 4 run data modify block -12 6 -3 {} merge from storage build:data signs.forest.time.10m
execute if score #forest_time value matches 5 run data modify block -12 6 -3 {} merge from storage build:data signs.forest.time.15m
execute if score #forest_time value matches 6 run data modify block -12 6 -3 {} merge from storage build:data signs.forest.time.20m
execute if score #forest_time value matches 7 run data modify block -12 6 -3 {} merge from storage build:data signs.forest.time.30m

data modify block -8 7 3 {} merge from storage build:data signs.forest.modifiers.up
data modify block -8 5 3 {} merge from storage build:data signs.forest.modifiers.down
execute if score #forest_modifiers value matches 0 run data modify block -8 6 3 {} merge from storage build:data signs.forest.modifiers.off
execute if score #forest_modifiers value matches 1 run data modify block -8 6 3 {} merge from storage build:data signs.forest.modifiers.fun
execute if score #forest_modifiers value matches 2 run data modify block -8 6 3 {} merge from storage build:data signs.forest.modifiers.annoying
execute if score #forest_modifiers value matches 3 run data modify block -8 6 3 {} merge from storage build:data signs.forest.modifiers.chaotic

execute if score #forest_teams value matches 0 run data modify block -8 7 -3 {} merge from storage build:data signs.forest.teams.off
execute if score #forest_teams value matches 1 run data modify block -8 7 -3 {} merge from storage build:data signs.forest.teams.on

execute if score #forest_entities value matches 0 run data modify block -8 6 -3 {} merge from storage build:data signs.forest.entities.off
execute if score #forest_entities value matches 1 run data modify block -8 6 -3 {} merge from storage build:data signs.forest.entities.on

execute if score #forest_custom_themes value matches 0 run data modify block -8 5 -3 {} merge from storage build:data signs.forest.custom_themes.off
execute if score #forest_custom_themes value matches 1 run data modify block -8 5 -3 {} merge from storage build:data signs.forest.custom_themes.on



execute if score #cave_phase value matches 0 run data modify block 14 5 0 {} merge from storage build:data signs.cave.start.start
execute if score #cave_phase value matches 1.. run data modify block 14 5 0 {} merge from storage build:data signs.cave.start.in_session

data modify block 12 7 -3 {} merge from storage build:data signs.cave.mode.up
data modify block 12 5 -3 {} merge from storage build:data signs.cave.mode.down
execute if score #cave_mode value matches 0 run data modify block 12 6 -3 {} merge from storage build:data signs.cave.mode.telephone
execute if score #cave_mode value matches 1 run data modify block 12 6 -3 {} merge from storage build:data signs.cave.mode.tourney
execute if score #cave_mode value matches 2 run data modify block 12 6 -3 {} merge from storage build:data signs.cave.mode.build_battle
execute if score #cave_mode value matches 3 run data modify block 12 6 -3 {} merge from storage build:data signs.cave.mode.1v1s

data modify block 12 7 3 {} merge from storage build:data signs.cave.time.up
data modify block 12 5 3 {} merge from storage build:data signs.cave.time.down
execute if score #cave_time value matches 0 run data modify block 12 6 3 {} merge from storage build:data signs.cave.time.1m
execute if score #cave_time value matches 1 run data modify block 12 6 3 {} merge from storage build:data signs.cave.time.2m
execute if score #cave_time value matches 2 run data modify block 12 6 3 {} merge from storage build:data signs.cave.time.3m
execute if score #cave_time value matches 3 run data modify block 12 6 3 {} merge from storage build:data signs.cave.time.5m
execute if score #cave_time value matches 4 run data modify block 12 6 3 {} merge from storage build:data signs.cave.time.10m
execute if score #cave_time value matches 5 run data modify block 12 6 3 {} merge from storage build:data signs.cave.time.15m
execute if score #cave_time value matches 6 run data modify block 12 6 3 {} merge from storage build:data signs.cave.time.20m
execute if score #cave_time value matches 7 run data modify block 12 6 3 {} merge from storage build:data signs.cave.time.30m

data modify block 8 7 -3 {} merge from storage build:data signs.cave.modifiers.up
data modify block 8 5 -3 {} merge from storage build:data signs.cave.modifiers.down
execute if score #cave_modifiers value matches 0 run data modify block 8 6 -3 {} merge from storage build:data signs.cave.modifiers.off
execute if score #cave_modifiers value matches 1 run data modify block 8 6 -3 {} merge from storage build:data signs.cave.modifiers.fun
execute if score #cave_modifiers value matches 2 run data modify block 8 6 -3 {} merge from storage build:data signs.cave.modifiers.annoying
execute if score #cave_modifiers value matches 3 run data modify block 8 6 -3 {} merge from storage build:data signs.cave.modifiers.chaotic

execute if score #cave_teams value matches 0 run data modify block 8 7 3 {} merge from storage build:data signs.cave.teams.off
execute if score #cave_teams value matches 1 run data modify block 8 7 3 {} merge from storage build:data signs.cave.teams.on

execute if score #cave_entities value matches 0 run data modify block 8 6 3 {} merge from storage build:data signs.cave.entities.off
execute if score #cave_entities value matches 1 run data modify block 8 6 3 {} merge from storage build:data signs.cave.entities.on

execute if score #cave_custom_themes value matches 0 run data modify block 8 5 3 {} merge from storage build:data signs.cave.custom_themes.off
execute if score #cave_custom_themes value matches 1 run data modify block 8 5 3 {} merge from storage build:data signs.cave.custom_themes.on



execute if score #city_phase value matches 0 run data modify block 0 5 -14 {} merge from storage build:data signs.city.start.start
execute if score #city_phase value matches 1.. run data modify block 0 5 -14 {} merge from storage build:data signs.city.start.in_session

data modify block -3 7 -12 {} merge from storage build:data signs.city.mode.up
data modify block -3 5 -12 {} merge from storage build:data signs.city.mode.down
execute if score #city_mode value matches 0 run data modify block -3 6 -12 {} merge from storage build:data signs.city.mode.telephone
execute if score #city_mode value matches 1 run data modify block -3 6 -12 {} merge from storage build:data signs.city.mode.tourney
execute if score #city_mode value matches 2 run data modify block -3 6 -12 {} merge from storage build:data signs.city.mode.build_battle
execute if score #city_mode value matches 3 run data modify block -3 6 -12 {} merge from storage build:data signs.city.mode.1v1s

data modify block 3 7 -12 {} merge from storage build:data signs.city.time.up
data modify block 3 5 -12 {} merge from storage build:data signs.city.time.down
execute if score #city_time value matches 0 run data modify block 3 6 -12 {} merge from storage build:data signs.city.time.1m
execute if score #city_time value matches 1 run data modify block 3 6 -12 {} merge from storage build:data signs.city.time.2m
execute if score #city_time value matches 2 run data modify block 3 6 -12 {} merge from storage build:data signs.city.time.3m
execute if score #city_time value matches 3 run data modify block 3 6 -12 {} merge from storage build:data signs.city.time.5m
execute if score #city_time value matches 4 run data modify block 3 6 -12 {} merge from storage build:data signs.city.time.10m
execute if score #city_time value matches 5 run data modify block 3 6 -12 {} merge from storage build:data signs.city.time.15m
execute if score #city_time value matches 6 run data modify block 3 6 -12 {} merge from storage build:data signs.city.time.20m
execute if score #city_time value matches 7 run data modify block 3 6 -12 {} merge from storage build:data signs.city.time.30m

data modify block -3 7 -8 {} merge from storage build:data signs.city.modifiers.up
data modify block -3 5 -8 {} merge from storage build:data signs.city.modifiers.down
execute if score #city_modifiers value matches 0 run data modify block -3 6 -8 {} merge from storage build:data signs.city.modifiers.off
execute if score #city_modifiers value matches 1 run data modify block -3 6 -8 {} merge from storage build:data signs.city.modifiers.fun
execute if score #city_modifiers value matches 2 run data modify block -3 6 -8 {} merge from storage build:data signs.city.modifiers.annoying
execute if score #city_modifiers value matches 3 run data modify block -3 6 -8 {} merge from storage build:data signs.city.modifiers.chaotic

execute if score #city_teams value matches 0 run data modify block 3 7 -8 {} merge from storage build:data signs.city.teams.off
execute if score #city_teams value matches 1 run data modify block 3 7 -8 {} merge from storage build:data signs.city.teams.on

execute if score #city_entities value matches 0 run data modify block 3 6 -8 {} merge from storage build:data signs.city.entities.off
execute if score #city_entities value matches 1 run data modify block 3 6 -8 {} merge from storage build:data signs.city.entities.on

execute if score #city_custom_themes value matches 0 run data modify block 3 5 -8 {} merge from storage build:data signs.city.custom_themes.off
execute if score #city_custom_themes value matches 1 run data modify block 3 5 -8 {} merge from storage build:data signs.city.custom_themes.on



execute if score #ice_phase value matches 0 run data modify block 0 5 14 {} merge from storage build:data signs.ice.start.start
execute if score #ice_phase value matches 1.. run data modify block 0 5 14 {} merge from storage build:data signs.ice.start.in_session

data modify block 3 7 12 {} merge from storage build:data signs.ice.mode.up
data modify block 3 5 12 {} merge from storage build:data signs.ice.mode.down
execute if score #ice_mode value matches 0 run data modify block 3 6 12 {} merge from storage build:data signs.ice.mode.telephone
execute if score #ice_mode value matches 1 run data modify block 3 6 12 {} merge from storage build:data signs.ice.mode.tourney
execute if score #ice_mode value matches 2 run data modify block 3 6 12 {} merge from storage build:data signs.ice.mode.build_battle
execute if score #ice_mode value matches 3 run data modify block 3 6 12 {} merge from storage build:data signs.ice.mode.1v1s

data modify block -3 7 12 {} merge from storage build:data signs.ice.time.up
data modify block -3 5 12 {} merge from storage build:data signs.ice.time.down
execute if score #ice_time value matches 0 run data modify block -3 6 12 {} merge from storage build:data signs.ice.time.1m
execute if score #ice_time value matches 1 run data modify block -3 6 12 {} merge from storage build:data signs.ice.time.2m
execute if score #ice_time value matches 2 run data modify block -3 6 12 {} merge from storage build:data signs.ice.time.3m
execute if score #ice_time value matches 3 run data modify block -3 6 12 {} merge from storage build:data signs.ice.time.5m
execute if score #ice_time value matches 4 run data modify block -3 6 12 {} merge from storage build:data signs.ice.time.10m
execute if score #ice_time value matches 5 run data modify block -3 6 12 {} merge from storage build:data signs.ice.time.15m
execute if score #ice_time value matches 6 run data modify block -3 6 12 {} merge from storage build:data signs.ice.time.20m
execute if score #ice_time value matches 7 run data modify block -3 6 12 {} merge from storage build:data signs.ice.time.30m

data modify block 3 7 8 {} merge from storage build:data signs.ice.modifiers.up
data modify block 3 5 8 {} merge from storage build:data signs.ice.modifiers.down
execute if score #ice_modifiers value matches 0 run data modify block 3 6 8 {} merge from storage build:data signs.ice.modifiers.off
execute if score #ice_modifiers value matches 1 run data modify block 3 6 8 {} merge from storage build:data signs.ice.modifiers.fun
execute if score #ice_modifiers value matches 2 run data modify block 3 6 8 {} merge from storage build:data signs.ice.modifiers.annoying
execute if score #ice_modifiers value matches 3 run data modify block 3 6 8 {} merge from storage build:data signs.ice.modifiers.chaotic

execute if score #ice_teams value matches 0 run data modify block -3 7 8 {} merge from storage build:data signs.ice.teams.off
execute if score #ice_teams value matches 1 run data modify block -3 7 8 {} merge from storage build:data signs.ice.teams.on

execute if score #ice_entities value matches 0 run data modify block -3 6 8 {} merge from storage build:data signs.ice.entities.off
execute if score #ice_entities value matches 1 run data modify block -3 6 8 {} merge from storage build:data signs.ice.entities.on

execute if score #ice_custom_themes value matches 0 run data modify block -3 5 8 {} merge from storage build:data signs.ice.custom_themes.off
execute if score #ice_custom_themes value matches 1 run data modify block -3 5 8 {} merge from storage build:data signs.ice.custom_themes.on